#ifndef __EXPRESION_H
#define __EXPRESION_H

#define max_exp 512     //Mximo nmero de elementos en una expresin
#define long_pila 2048  //Longitud de la pila en ejecucin

int pila[long_pila+max_exp+64]; // clculo de expresiones (compilacin y ejecucin)

// Tabla de elementos en la evaluacin de una expresin

struct exp_ele {
  byte tipo; // econs, eoper, erango, ewhoami, ecall
  union {
    int valor;
    int token;
    struct objeto * objeto;
  };
} tabexp[max_exp], *_exp;

#define econs   0       // Constante          // Tipos de elementos en tabexp[]
#define eoper   1       // Operador
#define erango  2       // Comprobacin de rango
#define ewhoami 3       // Identificador de proceso
#define ecall   4       // Creacin de un proceso
//#define efunc   5       // Llamada a una funcin interna
#define efext   6       // Llamada a una funcin externa
#define echeck  7       // Comprobacin de validez de un identificador
#define estring 8       // Cadena de texto (su offset constante)
#define enull   9       // Comprobacin de NULL pointer

//-----------------------------------------------------------------------------

void condicion(void);
void expresion(void);
void expresion_cpa(void);
void generar_expresion(void);
int constante(void);

#endif